; TIP1037.LSP: BTEXT.LSP    Insert Block Letter   BONUS WINNER
;                            (c)1994, Janet Morrison

;This lisp routine goes along with the block letters used in TIP #1006
;in the August 1994 issue.  This should simplify the insertion of the
;block letters considerably.  I tried to make this routine appear to
;work like the dtext command. The command is BTEXT.

(Defun dtr (A)
   (* pi (/ A 180.0))
) 

(DEFUN C:BTEXT (/ PT STRING H1 R1 PT1 BLK N)
   (command ".undo" "group")
   (setq string 0)
   (setq PT (getpoint "\n<Start point>: "))  ;text is always left justified
   (princ "\nHeight <") (princ H)
   (setq H1 (getreal ">: "))
   (if (/= H1 nil) 
      (setq H H1) 
   )
   (princ "\nRotation angle <") (princ r)
   (setq R1 (getreal ">: "))
   (if (/= R1 nil) 
      (setq R R1) 
   )
   (princ "\nWidth scale factor<")(princ wsf)
   (setq WSF1 (getreal ">: "))
   (if (/= WSF1 nil)
      (progn (setq WSF WSF1) (setq W (* WSF1 H))  )
      (setq W (* WSF H))  
   )
   (while (/= "" string)  ;enter will stop routine
      (setq string (getstring t "\nText: "))
      (setq N 1 PT1 PT)
      (repeat (strlen string)
         (setq BLK (substr string N 1))
         (if (/= BLK " ")                                  ;allows spaces
            (command ".insert" BLK PT1 W H R)  
         )
         (setq pt1 (polar pt1 (dtr r) w))            ;sets letter spacing
         (setq n (1+ n))
      );close repeat
      (setq pt (polar pt (dtr (- r 90)) (* h 1.6666666)));sets line spacing
   );close while
   (command ".undo" "end")
   (princ)
);close defun
